IMPLEMENTATION MODULE ClockDevice ;


FROM SYSTEM IMPORT WORD ;
FROM PortIO IMPORT Out32 ;


CONST
   InterruptBit       =    1 ;  (* Port is in the Interrupt Mode.        *)
   PerformOperationBit=    2 ;  (* Port initiate the input/output.       *)
   EnableInterruptBit =    3 ;  (* Enable Port interrupt.                *)

   IntDelayReg        =    5 ;  (* Interrupt delay register              *)
   ControlReg         =    2 ;  (* Control Register of the Port          *)
   IntNo              =   32 ;  (* Port #                                *)


(*
   LoadClock - returns the clock device current count.
*)

PROCEDURE LoadClock () : CARDINAL ;
BEGIN
   RETURN( 0 )
END LoadClock ;


(*
   StartClock - sets the Count into clock.
*)

PROCEDURE StartClock (Count: CARDINAL) ;
BEGIN
   (* software ready: enable device to give an interrupt when h/w ready *)
   Out32(IntNo, IntDelayReg, WORD(Count)) ;
   Out32(IntNo, ControlReg, WORD(2+4+8))
END StartClock ;


END ClockDevice.
