IMPLEMENTATION MODULE PortIO ;


(*
   In8 - returns a BYTE from port, Port.
*)

PROCEDURE In8 (Port: CARDINAL; reg: PortReg) : BYTE ;
BEGIN
   ASM
     load.d.d  12(%ra)       # Register
     load.d.d   8(%ra)       # Port number
     in
     store.d.d    %rd        # return value
   END
END In8 ;


(*
   Out8 - sends a byte, Value, to port, Port.
*)

PROCEDURE Out8 (Port: CARDINAL; reg: PortReg; Value: BYTE) ;
BEGIN
   ASM
     load.b.d  16(%ra)       # Value
     load.d.d  12(%ra)       # Register
     load.d.d   8(%ra)       # Port number
     out
   END
END Out8 ;


(*
   In32 - returns a WORD from port, Port.
*)

PROCEDURE In32 (Port: CARDINAL; reg: PortReg) : WORD ;
BEGIN
   ASM
     #
     # same assembly code as In8
     # the calling code will differ
     #
     load.d.d  12(%ra)       # Register
     load.d.d   8(%ra)       # Port number
     in
     store.d.d    %rd        # return value
   END
END In32 ;


(*
   Out32 - sends a byte, Value, to port, Port.
*)

PROCEDURE Out32 (Port: CARDINAL; reg: PortReg; Value: WORD) ;
BEGIN
   ASM
     load.d.d  16(%ra)       # Value
     load.d.d  12(%ra)       # Register
     load.d.d   8(%ra)       # Port number
     out
   END
END Out32 ;


END PortIO.
