IMPLEMENTATION MODULE SYSTEM ;


(*
   LISTEN - briefly listen for any interrupts.
*)

PROCEDURE LISTEN ;
VAR
   ToOldState: OnOrOff ;
BEGIN
   ToOldState := TurnInterrupts(On) ;
   (* interrupts are now on - now turn them back again *)
   ToOldState := TurnInterrupts(ToOldState) ;
END LISTEN ;


(*
   TurnInterrupts - switches interrupts on or off depending
                    on i. It returns the old value.
*)

PROCEDURE TurnInterrupts (Switch: OnOrOff) : OnOrOff ;
VAR
   im: CARDINAL ;
BEGIN
   im := GetIM() ;
   IF Switch=On
   THEN
      InterruptsOn
   ELSE
      InterruptsOff
   END ;
   IF im=0
   THEN
      RETURN( On )
   ELSE
      RETURN( Off )
   END
END TurnInterrupts ;


(*
   GetIM - returns a CARDINAL value of the %im register
*)

PROCEDURE GetIM () : CARDINAL ;
BEGIN
   ASM
      load.d.d  %im
      store.d.d %rd
   END
END GetIM ;


(*
   InterruptsOn - turn processor interrupts on.
*)

PROCEDURE InterruptsOn ;
BEGIN
   ASM
      load.d.d  $0
      store.d.d %em
      load.d.d  $0
      store.d.d %im
   END
END InterruptsOn ;


(*
   InterruptsOff - turn processor interrupts off.
*)

PROCEDURE InterruptsOff ;
BEGIN
   ASM
      load.d.d  $7
      store.d.d %im
   END
END InterruptsOff ;


END SYSTEM.
