IMPLEMENTATION MODULE libc ;


(*
     int write(d, buf, nbytes)
     int d;
     char *buf;
     int nbytes;
*)

PROCEDURE write (d: INTEGER; buf: ADDRESS; nbytes: INTEGER) : INTEGER ;
BEGIN
   ASM
      load.d.d   16(%ra)  # nbytes
      load.d.d   12(%ra)  # buf
      load.d.d   8(%ra)   # d
      load.d.d  $2        # SysCallWrite
      load.d.d  $0        # SyscallTrap
      trap
      store.d.d %rd       # return result
   END
END write ;


(*
     int read(d, buf, nbytes)
     int d;
     char *buf;
     int nbytes;
*)

PROCEDURE read (d: INTEGER; buf: ADDRESS; nbytes: INTEGER) : INTEGER ;
BEGIN
   ASM
      load.d.d   16(%ra) # nbytes
      load.d.d   12(%ra) # buf
      load.d.d   8(%ra)  # d
      load.d.d  $1        # SysCallWrite
      load.d.d  $0        # SyscallTrap
      trap
      store.d.d %rd       # return result
   END
END read ;


(*
     system(string)
     char *string;
*)

PROCEDURE system (a: ADDRESS) : INTEGER ;
BEGIN
   (* unfinished *)
   exit(1) ;
   RETURN( 0 )
END system ;


PROCEDURE malloc (size: CARDINAL) : ADDRESS ;
BEGIN
   exit(1) ;
   RETURN( NIL )
END malloc ;


(*
     cfree - memory deallocator.
 
     cfree(ptr)
     char *ptr;

     free() releases a previously allocated block.  Its argument
     is a pointer to a block previously allocated by malloc, cal-
     loc, realloc, malloc, or memalign.
*)

PROCEDURE cfree (ptr: ADDRESS) ;
BEGIN
   abort
END cfree ;


PROCEDURE isatty () : BOOLEAN ;
BEGIN
   RETURN( FALSE )
END isatty ;


(*
   getenv - returns the C string for the equivalent C environment
            variable.
*)

PROCEDURE getenv (s: ADDRESS) : ADDRESS ;
BEGIN
   exit(1) ;
   RETURN( NIL )
END getenv ;


(*
   getpid - returns the UNIX process identification number.
*)

PROCEDURE getpid () : CARDINAL ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END getpid ;


(*
   dup - duplicates the file descriptor, d.
*)

PROCEDURE dup (d: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END dup ;


(*
   close - closes the file descriptor, d.
*)

PROCEDURE close (d: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END close ;


(*
   abort - stop the simulation due to an error
*)

PROCEDURE abort ;
BEGIN
   ASM
      halt   #  something went very wrong
   END
END abort ;


(*
   exit - terminate the simulation
*)

PROCEDURE exit (r: INTEGER) ;
BEGIN
   ASM
      load.d.d  $0    # ExitSyscall
      load.d.d  $0    # SyscallTrap
      trap
      #
      # should never return from exit..
      #
   END
END exit ;


(*
   chown - The  owner  of  the  file  specified  by  path or by fd is
           changed.  Only the super-user may change the  owner  of  a
           file.   The  owner  of  a file may change the group of the
           file to any group of which that owner is  a  member.   The
           super-user may change the group arbitrarily.

           If  the owner or group is specified as -1, then that ID is
           not changed.

           On success, zero is returned.  On error, -1  is  returned,
           and errno is set appropriately.
*)

PROCEDURE chown (filename: ADDRESS; uid, gid: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END chown ;


(*
   getcwd - copies the absolute pathname of  the
            current  working directory to the array pointed to by buf,
            which is of length size.

            If the current absolute path name would require  a  buffer
            longer  than size elements, NULL is returned, and errno is
            set to ERANGE; an application should check for this error,
            and allocate a larger buffer if necessary.
*)

PROCEDURE getcwd (buf: ADDRESS; size: INTEGER) : ADDRESS ;
BEGIN
   exit(1) ;
   RETURN( NIL )
END getcwd ;


(*
   setenv - adds the variable name to the environment with the
            value value, if name does not already exist.
            If name does exist in the environment, then its
            value is changed to value if overwrite is non-zero;
            if overwrite is zero, then the value of name is not changed.

            The setenv function returns zero on success, or -1 if
            there was insufficient space in the environment.
*)

PROCEDURE setenv (name, value: ADDRESS; overwrite: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END setenv ;


(*
   environ - returns the libc variable environ.
*)

PROCEDURE environ () : ADDRESS ;
BEGIN
   exit(1) ;
   RETURN( NIL )
END environ ;


(*
   open - open the file, filename with flag and mode.
*)

PROCEDURE open (filename: ADDRESS; flag, mode: CARDINAL) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END open ;


(* 
   creat - creates a new file 
*)

PROCEDURE creat (filename : ADDRESS; mode : CARDINAL) : INTEGER;
BEGIN
   exit(1) ;
   RETURN( 0 )
END creat ;


(*
   lseek - calls unix lseek:

           off_t lseek(int fildes, off_t offset, int whence);
*)

PROCEDURE lseek (fd: INTEGER; offset: INTEGER; whence: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END lseek ;


(* 
   perror - writes errno and string 
*)

PROCEDURE perror (string: ADDRESS) ;
BEGIN
   exit(1)
END perror ;


(*
   readv - reads an io vector of bytes.
*)

PROCEDURE readv (fd: INTEGER; v: ADDRESS; n: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END readv ;


(*
   writev - writes an io vector of bytes.
*)

PROCEDURE writev (fd: INTEGER; v: ADDRESS; n: INTEGER) : INTEGER ;
BEGIN
   exit(1) ;
   RETURN( 0 )
END writev ;


END libc.
